Attribute VB_Name = "GaussMethod"
Option Explicit
Option Base 1


Sub main() '  
  Dim a() As Single, b() As Single, x() As Single
  Dim i As Integer, j As Integer
  
  
  ReDim a(3, 3)
'  For i = 1 To 10
'    For j = 1 To 10
'      If (i <> j) Then
'        a(i, j) = 0.97
'      Else
'        a(i, j) = 1
'      End If
'    Next j
'  Next i
      
  a(1, 1) = 0.04: a(1, 2) = 0.04: a(1, 3) = 0.04
  a(2, 1) = 1: a(2, 2) = 2: a(2, 3) = 3
  a(3, 1) = 4: a(3, 2) = 0.24: a(3, 3) = -0.08
  'a(4, 1) = 1: a(4, 2) = 1: a(4, 3) = -1
  
'  For i = -2 To 3
'    For j = -1 To 5
'      a(i, j) = i * j
'    Next j
'  Next i
  ReDim b(3)
  b(1) = 3 ': b(1, 2) = 6 ': b(1, 3) = 1: b(1, 4) = 1
  b(2) = 2 ': b(2, 2) = 8  ': b(2, 3) = -1: b(2, 4) = 1
  b(3) = 1 ': b(3, 2) = 1: b(3, 3) = -1: b(3, 4) = -1
'  b(1, 1) = 8 ': b(1, 2) = 6 ': b(1, 3) = 1: b(1, 4) = 1
'  b(2, 1) = 9 ': b(2, 2) = 8  ': b(2, 3) = -1: b(2, 4) = 1
'  b(3, 1) = 20 ': b(3, 2) = 1: b(3, 3) = -1: b(3, 4) = -1

  
  'ReDim b(10)
'  For i = -2 To 3
'    b(i) = i
'  Next i

  Call SolutionLinearEquations(a, b, x) '   
  

End Sub


Sub SolutionLinearEquations(a() As Single, b() As Single, x() As Single)
  Dim b1 As Single '   
  '     : AX=B, 
  ' A -     X
  ' B -    
  '    X=(A1)B, 
  ' A1 -   

  Call Set2MinIndexTo1(a)  '      ..,      1
  Call Set1MinIndexTo1(b)  '     ..,      1
  b1 = Determinant(a)
  If (b1 = 0) Then Stop    ' =0, ..  
  Call Gaussj(a) ', b)     '   A1,   A  
  ' A -        
  Call MultipleMatrix(a, b, x) '   A1*B=X
End Sub



'     (n*n), n>2; (  =1)
Function Determinant(x() As Single) As Single  '  
'        ,  , 
'     , ..      . 
'    : D=X11*X22*...*Xnn,  Xii -  ,  
'     (   ,    
'          , 
'    ( )    ).

'             
' .      X=Y*Z, 
'     Y11   0 ...   0        1  Z12 ... Z1n
' Y = Y21 Y22 ...   0, Z =   0    1 ... Z2n.      
'     ... ... ... ...      ...  ... ... ...
'     Yn1 Yn2 ... Ynn        0    0 ...   1
'   Y  Z: X=Y*Z,   Z=1 (  ) 
' X=Y11*Y22*...*Yynn.
    Dim y() As Single, z As Single, s As Single, p As Single
    Dim i As Integer, j As Integer, k As Integer, l As Integer, n As Integer
    Dim c As Integer ' 
    On Error GoTo ErrorHandler:
    
    n = UBound(x, 1) '   (>2)
    If (n <> UBound(x, 2) Or n < 3) Then Exit Function '   
    ReDim y(1 To n, 1 To n)
    p = 1#
    c = 0        '   Z  Y   Y
    For i = 1 To n   '    
      y(i, 1) = x(i, 1)
      For j = 2 To n '   
        If (i >= j) Then
          k = j - 1 '      Y
        Else
          k = i - 1 '      Z
        End If
        s = 0#   ' 
        For l = 1 To k
          s = s + y(i, l) * y(l, j)
        Next l
        y(i, j) = x(i, j) - s
        If (j > i) Then y(i, j) = y(i, j) / y(i, i) '   Z
      Next j
      z = y(i, i)
      Do While (Abs(z) < 1) ' ,  z<1
        z = 10 * z '  z  10 
        c = c - 1  '   
      Loop
      p = p * z '  ,    
      Do While (Abs(p) > 10) ' ,  p>10
        p = 0.1 * p '  p  10 
        c = c + 1 '  
      Loop
    Next i
    Determinant = p * 10 ^ c
    '  :
    ' 1.       ,     
    ' 2. ,     (),  
    ' 3.       -   ()    (),
    '       
    ' 4. AB=A*B
    Erase y
    Exit Function
ErrorHandler: '  
    Determinant = 0 '   
End Function



Sub MultipleMatrix(a() As Single, b() As Single, c() As Single)
'    A(m*n)   B(n*p) c   C(m*p)
'      1
    Dim i As Integer, j As Integer, k As Integer, m As Integer, p As Integer, n As Integer
    m = UBound(a, 1): n = UBound(a, 2)   ' -     
    If (n <> UBound(b, 1)) Then Exit Sub '   
    On Error Resume Next
    p = UBound(b, 2) ' -   B
    If (Err.Number = 9) Then  '  B  ,    9 ("Subscript out of range")
      Erase c
      ReDim c(1 To m) '   C  
      For i = 1 To m
        For k = 1 To n
          c(i) = c(i) + a(i, k) * b(k)
        Next k
      Next i
    Else
      Erase c
      ReDim c(1 To m, 1 To p) '   C
      For i = 1 To m
        For j = 1 To p
          For k = 1 To n
            c(i, j) = c(i, j) + a(i, k) * b(k, j)
          Next k
        Next j
      Next i
    End If
'     
'     m*n=2*3        n*p=3*2     m*p=2*2          c11 = a11 * b11 + a12 * b21 + a13 * b31
'                                                 c12 = a11 * b12 + a12 * b22 + a13 * b32
'    a11 a12 a13 * b11 b12 = c11 c12  ,  c21 = a21 * b11 + a22 * b21 + a23 * b31
'    a21 a22 a23   b21 b22   c21 c22        c22 = a21 * b12 + a22 * b22 + a23 * b32
'                    b31 b32
End Sub


'   A,        
'   
Sub Gaussj(a() As Single)
    ' m -  , n -  
    ' a -       
    Dim m As Integer, n As Integer, NMAX As Integer
    Dim i As Integer, icol As Integer, irow As Integer, j As Integer, k As Integer, l As Integer
    Dim ll As Integer, indxc() As Integer, indxr() As Integer, ipiv() As Integer
    Dim big As Single, dum As Single, PivInv As Single
    
    m = UBound(a, 1): n = UBound(a, 2)
    ReDim indxc(1 To n), indxr(1 To n), ipiv(1 To n)
    
    For i = 1 To n
      big = 0#
      For j = 1 To n
        If (ipiv(j) <> 1) Then
          For k = 1 To n
            If (ipiv(k) = 0) Then
              If (Abs(a(j, k)) >= big) Then
                big = Abs(a(j, k))
                irow = j
                icol = k
              End If
            ElseIf (ipiv(k) > 1) Then
              Err = "    gaussj"
              Stop 'singular matrix in gaussj'
            End If
          Next k
        End If
      Next j
      ipiv(icol) = ipiv(icol) + 1
      If (irow <> icol) Then
        For l = 1 To n
          dum = a(irow, l)
          a(irow, l) = a(icol, l)
          a(icol, l) = dum
        Next l
      End If
      indxr(i) = irow
      indxc(i) = icol
      If (a(icol, icol) = 0#) Then Err = "    gaussj": Stop
      PivInv = 1# / a(icol, icol)
      a(icol, icol) = 1#
      For l = 1 To n
        a(icol, l) = a(icol, l) * PivInv
      Next l
      For ll = 1 To n
        If (ll <> icol) Then
          dum = a(ll, icol)
          a(ll, icol) = 0#
          For l = 1 To n
            a(ll, l) = a(ll, l) - a(icol, l) * dum
          Next l
        End If
      Next ll
    Next i
    For l = n To 1 Step -1
      If (indxr(l) <> indxc(l)) Then
        For k = 1 To n
          dum = a(k, indxr(l))
          a(k, indxr(l)) = a(k, indxc(l))
          a(k, indxc(l)) = dum
        Next k
      End If
    Next l
    Erase indxc, indxr, ipiv
End Sub


'     ..,      1
Sub Set1MinIndexTo1(a() As Single)
'   a(-2:3),    at(1:6)
' a -  , at - 
  Dim imin As Integer, imax As Integer
  Dim i As Integer, d As Integer
  Dim at() As Single
  imin = LBound(a, 1): imax = UBound(a, 1)
  d = imax - imin + 1
  ReDim at(1 To d)
  For i = 1 To d
    at(i) = a(imin)
    imin = imin + 1
  Next i
  Erase a
  ReDim a(1 To d)
  For i = 1 To d
    a(i) = at(i)
  Next i
  Erase at
End Sub


'      ..,      1
Sub Set2MinIndexTo1(a() As Single)
'   a(-2:3,-1:5),    at(1:6, 1:7)
' a -  , at - 
  Dim imin1 As Integer, imin2 As Integer, imax1 As Integer, imax2 As Integer
  Dim ii As Integer, jj As Integer, i As Integer, j As Integer
  Dim d1 As Integer, d2 As Integer
  Dim at() As Single
  imin1 = LBound(a, 1): imin2 = LBound(a, 2)
  imax1 = UBound(a, 1): imax2 = UBound(a, 2)
  d1 = imax1 - imin1 + 1: d2 = imax2 - imin2 + 1
  Erase at
  ReDim at(1 To d1, 1 To d2)
  ii = imin1
  For i = 1 To d1
    jj = imin2
    For j = 1 To d2
      at(i, j) = a(ii, jj)
      jj = jj + 1
    Next j
    ii = ii + 1
  Next i
  Erase a
  ReDim a(1 To d1, 1 To d2)
  For i = 1 To d1
    For j = 1 To d2
      a(i, j) = at(i, j)
    Next j
  Next i
  Erase at
End Sub
